#ifndef SOCKETWRAPPERLINUX_H_
#define SOCKETWRAPPERLINUX_H_

#include <string>
#include "UniSocket.hpp"

#include <netinet/in.h>      // For sockaddr_in

class SocketWrapper {

private:
	sockaddr_in _address;
	int _socket;
	std::string _end;

public:
	std::string _ip;
	
	SocketWrapper(void);
	
	SocketWrapper(
		const std::string & ip,
		const int & port,
		const std::string & end
	);
	
	void send(const std::string & data);
	std::string recv(void);
	void close(void);

	// server
	SocketWrapper(
		const int & port,
		const int & queueSize,
		const std::string & end
	);
	SocketWrapper(
		const sockaddr_in & myAddress,
		const int & mySocket,
		const std::string & end
	);
	SocketWrapper accept(void);
};

#endif
